# Crashpad: crashpad::internal::MinidumpStringWriter< Traits > Class Template Reference

crashpad::internal::MinidumpStringWriter< Traits > Class Template Reference

Writes a variable-length string to a minidump file in accordance with the string type’s characteristics. More...

`#include "minidump/minidump_string_writer.h"`

Inheritance diagram for crashpad::internal::MinidumpStringWriter< Traits >:

## Protected Types

using | MinidumpStringType = typename Traits::MinidumpStringType
using | StringType = typename Traits::StringType
Protected Types inherited from crashpad::internal::MinidumpWritable
enum | State
| Identifies the state of an object. More...
enum | Phase
| Identifies the phase during which an object will be written to a minidump file. More...

## Protected Member Functions

bool | Freeze () override
| Transitions the object from kStateMutable to kStateFrozen. More...
size_t | SizeOfObject () override
| Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment. More...
bool | WriteObject (FileWriterInterface *file_writer) override
| Writes the object’s content. More...
void | set_string (const StringType &string)
| Sets the string to be written. More...
const StringType & | string () const
| Retrieves the string to be written. More...
Protected Member Functions inherited from crashpad::internal::MinidumpWritable
State | state () const
| The state of the object.
virtual size_t | Alignment ()
| Returns the object’s desired byte-boundary alignment. More...
virtual std::vector< MinidumpWritable * > | Children ()
| Returns the object’s children. More...
virtual Phase | WritePhase ()
| Returns the object’s desired write phase. More...
size_t | WillWriteAtOffset (Phase phase, FileOffset *offset, std::vector< MinidumpWritable *> *write_sequence)
| Prepares the object to be written at a known file offset, transitioning it from kStateFrozen to kStateWritable. More...
virtual bool | WillWriteAtOffsetImpl (FileOffset offset)
| Called once an object’s writable file offset is determined, as it transitions into kStateWritable. More...
bool | WritePaddingAndObject (FileWriterInterface *file_writer)
| Writes the object, transitioning it from kStateWritable to kStateWritten. More...

## Additional Inherited Members

Public Member Functions inherited from crashpad::internal::MinidumpWritable
virtual bool | WriteEverything (FileWriterInterface *file_writer)
| Writes an object and all of its children to a minidump file. More...
void | RegisterRVA (RVA *rva)
| Registers a file offset pointer as one that should point to the object on which this method is called. More...
void | RegisterLocationDescriptor (MINIDUMP_LOCATION_DESCRIPTOR *location_descriptor)
| Registers a location descriptor as one that should point to the object on which this method is called. More...
Static Protected Attributes inherited from crashpad::internal::MinidumpWritable
static const size_t | kInvalidSize
| A size value used to signal failure by methods that return `size_t`. More...

## Detailed Description

### template<typename Traits>
class crashpad::internal::MinidumpStringWriter< Traits >

Writes a variable-length string to a minidump file in accordance with the string type’s characteristics.

MinidumpStringWriter objects should not be instantiated directly. To write strings to minidump file, use the MinidumpUTF16StringWriter and MinidumpUTF8StringWriter subclasses instead.

## Member Function Documentation

## Freeze()

template<typename Traits >

bool crashpad::internal::MinidumpStringWriter< Traits >::Freeze | ( |  | ) |

overrideprotectedvirtual

Transitions the object from kStateMutable to kStateFrozen.

The default implementation marks the object as frozen and recursively calls Freeze() on all of its children. Subclasses may override this method to perform processing that should only be done once callers have finished populating an object with data. Typically, a subclass implementation would call RegisterRVA() or RegisterLocationDescriptor() on other objects as appropriate, because at the time Freeze() runs, the in-memory locations of RVAs and location descriptors are known and will not change for the remaining duration of an object’s lifetime.

Returns
  `true` on success. `false` on failure, with an appropriate message logged.

Reimplemented from crashpad::internal::MinidumpWritable.

## set_string()

template<typename Traits>

void crashpad::internal::MinidumpStringWriter< Traits >::set_string | ( | const StringType & | string | ) |

inlineprotected

Sets the string to be written.

Note
  Valid in kStateMutable.

## SizeOfObject()

template<typename Traits >

size_t crashpad::internal::MinidumpStringWriter< Traits >::SizeOfObject | ( |  | ) |

overrideprotectedvirtual

Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment.

Note
  Valid in kStateFrozen or any subsequent state.

Implements crashpad::internal::MinidumpWritable.

## string()

template<typename Traits>

const StringType& crashpad::internal::MinidumpStringWriter< Traits >::string | ( |  | ) | const

inlineprotected

Retrieves the string to be written.

Note
  Valid in any state.

## WriteObject()

template<typename Traits >

bool crashpad::internal::MinidumpStringWriter< Traits >::WriteObject | ( | FileWriterInterface * | file_writer | ) |

overrideprotectedvirtual

Writes the object’s content.

Parameters

  [in] | file_writer | The file writer to receive the object’s content.

Returns
  `true` on success. `false` on error, indicating that the content could not be written to the minidump file.

Note
  Valid in kStateWritable. The object will transition to kStateWritten after this method returns.

Implements crashpad::internal::MinidumpWritable.

The documentation for this class was generated from the following files:

- minidump/minidump_string_writer.h
- minidump/minidump_string_writer.cc